#include <Rcpp.h>
using namespace Rcpp;

// [[Rcpp::export]]
IntegerVector Cna_fill_int(IntegerVector xx, unsigned int type = 1, bool inplace = false) {
  IntegerVector x = inplace ? xx : clone(xx);
  R_xlen_t n = x.size();
  if (type & 0b01) {
    for(R_xlen_t i = 1; i<n; i++) {
      if(IntegerVector::is_na(x[i]) && !IntegerVector::is_na(x[i-1])) {
        x[i] = x[i-1];
      }
    }
  }
  if (type & 0b10) {
    for(R_xlen_t i = n - 1; i>=0; i--) {
      if(IntegerVector::is_na(x[i-1]) && !IntegerVector::is_na(x[i])) {
        x[i-1] = x[i];
      }
    }
  }
  return x;
}

// [[Rcpp::export]]
NumericVector Cna_fill_num(NumericVector xx, unsigned int type = 1, bool inplace = false) {
  NumericVector x = inplace ? xx : clone(xx);
  R_xlen_t n = x.size();
  if (type & 0b01) {
    for(R_xlen_t i = 1; i<n; i++) {
      if(NumericVector::is_na(x[i]) && !NumericVector::is_na(x[i-1])) {
        x[i] = x[i-1];
      }
    }
  }
  if (type & 0b10) {
    for(R_xlen_t i = n - 1; i>=0; i--) {
      if(NumericVector::is_na(x[i-1]) && !NumericVector::is_na(x[i])) {
        x[i-1] = x[i];
      }
    }
  }
  return x;
}

// [[Rcpp::export]]
StringVector Cna_fill_char(StringVector xx, unsigned int type = 1, bool inplace = false) {
  StringVector x = inplace ? xx : clone(xx);
  R_xlen_t n = x.size();
  if (type & 0b01) {
    for(R_xlen_t i = 1; i<n; i++) {
      if(StringVector::is_na(x[i]) && !StringVector::is_na(x[i-1])) {
        x[i] = x[i-1];
      }
    }
  }
  if (type & 0b10) {
    for(R_xlen_t i = n - 1; i>=0; i--) {
      if(StringVector::is_na(x[i-1]) && !StringVector::is_na(x[i])) {
        x[i-1] = x[i];
      }
    }
  }
  return x;
}
