library(data.table)
Rcpp::sourceCpp('na_fill.cpp')
Rcpp::sourceCpp('na_fill_grp.cpp')
source("na_fill.R")
source("na_fill_grp.R")

ngrp <- 1800000
nbygrp <- 50

dt <- data.table(
  id=rep(1:ngrp, each=nbygrp),
  a=sample(1:100, nbygrp * ngrp, replace=T),
  b=sample(LETTERS, nbygrp * ngrp, replace=T),
  c=sample((1:100 + 0.5), nbygrp * ngrp, replace=T),
  d=sample(1:100, nbygrp * ngrp, replace=T),
  e=sample(1:100, nbygrp * ngrp, replace=T)
)
dt[(1:.N %% 2 == 0), a:=NA]
dt[(1:.N %% 3 == 0), b:=NA]
dt[(1:.N %% 4 == 0), c:=NA]
dt[(1:.N %% 5 == 0), d:=NA]
dt[(1:.N %% 6 == 0), e:=NA]

vars2 = c("a", "c", "d", "e")
outvars2 <- paste0("z", vars2)

setDTthreads()

vars2 = c("a", "c", "d", "e")
dt0 <- copy(dt)
system.time(dt0[, (vars2):=setnafill(.SD, type="locf", cols=vars2), .SDcols=vars2, by="id"])
dt1 <- copy(dt)
system.time(dt1[, (vars2) := lapply(.SD, function(x) na_fill(x, inplace=T)), by="id", .SDcols = vars2, verbose=T])
dt2 <- copy(dt)
system.time(na_fill_grp(dt2, var=vars2, by="id", inplace=T))
identical(dt0, dt1)
identical(dt1, dt2)
